These are type cleanups and a genuine bug fix. 
Signed-off-by: Ronald G. Minnich <rminnich@gmail.com>

Index: device/pci_device.c
===================================================================
--- device/pci_device.c	(revision 493)
+++ device/pci_device.c	(working copy)
@@ -661,7 +661,7 @@
 	ram = pci_rom_load(dev, rom);
 	if (ram == NULL)
 		return;
-	run_bios(dev, ram);
+	run_bios(dev, (unsigned long)ram);
 #endif
 }
 
Index: lib/lar.c
===================================================================
--- lib/lar.c	(revision 493)
+++ lib/lar.c	(working copy)
@@ -107,8 +107,8 @@
 			result->len = ntohl(header->len);
 			result->reallen = ntohl(header->reallen);
 			result->compression = ntohl(header->compression);
-			result->entry = (void *)ntohl(header->entry);
-			result->loadaddress = (void *)ntohl(header->loadaddress);
+			result->entry = (void *)ntohl((u32)header->entry);
+			result->loadaddress = (void *)ntohl((u32)header->loadaddress);
 			printk(BIOS_SPEW, 
 			"start %p len %d reallen %d compression %x entry %p loadaddress %p\n", 
 				result->start, result->len, result->reallen, 
Index: arch/x86/stage1.c
===================================================================
--- arch/x86/stage1.c	(revision 493)
+++ arch/x86/stage1.c	(working copy)
@@ -56,14 +56,13 @@
 int legacy(struct mem_file *archive, char *name, void *where, struct lb_memory *mem)
 {
 	int ret;
-	struct mem_file result;
 	int elfboot_mem(struct lb_memory *mem, void *where, int size);
 	ret = copy_file(archive, name, where);
 	if (ret) {
 		printk(BIOS_ERR, "'%s' found, but could not load it.\n", name);
 	}
 
-	ret =  elfboot_mem(mem, where, result.reallen);
+	ret =  elfboot_mem(mem, where, archive->reallen);
 
 	printk(BIOS_ERR, "elfboot_mem returns %d\n", ret);
 	return -1;
Index: util/lar/stream.c
===================================================================
--- util/lar/stream.c	(revision 493)
+++ util/lar/stream.c	(working copy)
@@ -79,7 +79,7 @@
 	u32 entry;
 	int i;
 	int size;
-	unsigned char *header;
+	char *header;
 	char ename[64];
 	int headers;
 	char *temp;
@@ -101,7 +101,7 @@
 	/* validate elf header */
 	ehdr = (Elf32_Ehdr *)filebuf;
 	headers = ehdr->e_phnum;
-	header  = (unsigned char *)ehdr;
+	header  = (char *)ehdr;
 	if (verbose())
 		fprintf(stderr, "Type %d machine %d version %d entry %p phoff %d shoff %d flags %#x hsize %d phentsize %d phnum %d s_hentsize %d s_shnum %d \n", 
 		ehdr->e_type,
